ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
Revision: 2.18
Committed: Wed Jun 1 22:50:24 2011 UTC (12 years, 10 months ago) by greg
Content type: text/plain
Branch: MAIN
Changes since 2.17: +2 -2 lines
Log Message:
Fixed bug in computation of isotropic distribution

File Contents

# User Rev Content
1 greg 2.1 #!/usr/bin/perl -w
2 greg 2.18 # RCSid $Id: genBSDF.pl,v 2.17 2011/06/01 00:29:40 greg Exp $
3 greg 2.1 #
4     # Compute BSDF based on geometry and material description
5     #
6     # G. Ward
7     #
8     use strict;
9 greg 2.13 use File::Temp qw/ :mktemp /;
10 greg 2.1 sub userror {
11 greg 2.15 print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
12 greg 2.1 exit 1;
13     }
14 greg 2.13 my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15 greg 2.1 chomp $td;
16 greg 2.15 my $tensortree = 0;
17     my $ttlog2 = 4;
18 greg 2.1 my $nsamp = 1000;
19 greg 2.10 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
20 greg 2.1 my $mgfin = 0;
21     my $geout = 1;
22     my $nproc = 1;
23 greg 2.9 my $doforw = 0;
24     my $doback = 1;
25 greg 2.1 my @dim;
26     # Get options
27     while ($#ARGV >= 0) {
28     if ("$ARGV[0]" =~ /^[-+]m/) {
29     $mgfin = ("$ARGV[0]" =~ /^\+/);
30 greg 2.10 } elsif ("$ARGV[0]" eq "-r") {
31     $rtargs = "$rtargs $ARGV[1]";
32     shift @ARGV;
33 greg 2.1 } elsif ("$ARGV[0]" =~ /^[-+]g/) {
34     $geout = ("$ARGV[0]" =~ /^\+/);
35 greg 2.9 } elsif ("$ARGV[0]" =~ /^[-+]f/) {
36     $doforw = ("$ARGV[0]" =~ /^\+/);
37     } elsif ("$ARGV[0]" =~ /^[-+]b/) {
38     $doback = ("$ARGV[0]" =~ /^\+/);
39 greg 2.15 } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
40     $tensortree = substr($ARGV[0], 2, 1);
41     $ttlog2 = $ARGV[1];
42     shift @ARGV;
43 greg 2.1 } elsif ("$ARGV[0]" eq "-c") {
44     $nsamp = $ARGV[1];
45     shift @ARGV;
46     } elsif ("$ARGV[0]" eq "-n") {
47     $nproc = $ARGV[1];
48     shift @ARGV;
49     } elsif ("$ARGV[0]" =~ /^-d/) {
50     userror() if ($#ARGV < 6);
51 greg 2.8 @dim = @ARGV[1..6];
52 greg 2.1 shift @ARGV for (1..6);
53     } elsif ("$ARGV[0]" =~ /^[-+]./) {
54     userror();
55     } else {
56     last;
57     }
58     shift @ARGV;
59     }
60 greg 2.9 # Check that we're actually being asked to do something
61 greg 2.15 die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
62     # Name our own persist file?
63     my $persistfile;
64     if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
65     $persistfile = "$td/pfile.txt";
66     $rtargs = "-PP $persistfile $rtargs";
67     }
68 greg 2.1 # Get scene description and dimensions
69     my $radscn = "$td/device.rad";
70     my $mgfscn = "$td/device.mgf";
71     my $octree = "$td/device.oct";
72     if ( $mgfin ) {
73     system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
74     die "Could not load MGF input\n" if ( $? );
75     system "mgf2rad $mgfscn > $radscn";
76     } else {
77 greg 2.13 system "xform -e @ARGV > $radscn";
78 greg 2.1 die "Could not load Radiance input\n" if ( $? );
79     system "rad2mgf $radscn > $mgfscn" if ( $geout );
80     }
81     if ($#dim != 5) {
82 greg 2.7 @dim = split ' ', `getbbox -h $radscn`;
83 greg 2.1 }
84     print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
85 greg 2.9 # Add receiver surfaces (rectangular)
86 greg 2.10 my $fmodnm="receiver_face";
87 greg 2.9 my $bmodnm="receiver_behind";
88 greg 2.1 open(RADSCN, ">> $radscn");
89 greg 2.10 print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
90     print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
91     print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
92     print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
93 greg 2.1 close RADSCN;
94     # Generate octree
95     system "oconv -w $radscn > $octree";
96     die "Could not compile scene\n" if ( $? );
97 greg 2.15 # Output XML prologue
98     print
99     '<?xml version="1.0" encoding="UTF-8"?>
100     <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
101     <WindowElementType>System</WindowElementType>
102     <Optical>
103     <Layer>
104     <Material>
105     <Name>Name</Name>
106     <Manufacturer>Manufacturer</Manufacturer>
107     ';
108     printf "\t\t<Thickness unit=\"Meter\">%.3f</Thickness>\n", $dim[5] - $dim[4];
109     printf "\t\t<Width unit=\"Meter\">%.3f</Width>\n", $dim[1] - $dim[0];
110     printf "\t\t<Height unit=\"Meter\">%.3f</Height>\n", $dim[3] - $dim[2];
111     print "\t\t<DeviceType>Integral</DeviceType>\n";
112     # Output MGF description if requested
113     if ( $geout ) {
114     print "\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
115     printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
116     open(MGFSCN, "< $mgfscn");
117     while (<MGFSCN>) { print $_; }
118     close MGFSCN;
119     print "xf\n";
120     print "\t\t</Geometry>\n";
121     }
122     print " </Material>\n";
123     # Set up surface sampling
124     my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
125     my $ny = int($nsamp/$nx + .5);
126     $nsamp = $nx * $ny;
127     my $ns = 2**$ttlog2;
128     my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
129     # Create data segments (all the work happens here)
130     if ( $tensortree ) {
131     do_tree_bsdf();
132     } else {
133     do_matrix_bsdf();
134     }
135     # Output XML epilogue
136     print
137     '</Layer>
138     </Optical>
139     </WindowElement>
140     ';
141     # Clean up temporary files and exit
142 greg 2.16 if ( $persistfile && open(PFI, "< $persistfile") ) {
143 greg 2.15 while (<PFI>) {
144     s/^[^ ]* //;
145     kill('ALRM', $_);
146     last;
147     }
148     close PFI;
149     }
150 greg 2.16 exec("rm -rf $td");
151    
152 greg 2.15 #-------------- End of main program segment --------------#
153    
154     #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
155     sub do_tree_bsdf {
156     # Get sampling rate and subdivide task
157     my $ns2 = $ns;
158     $ns2 /= 2 if ( $tensortree == 3 );
159     @pdiv = (0, int($ns2/$nproc));
160     my $nrem = $ns2 % $nproc;
161     for (my $i = 1; $i < $nproc; $i++) {
162     my $nv = $pdiv[$i] + $pdiv[1];
163     ++$nv if ( $nrem-- > 0 );
164     push @pdiv, $nv;
165     }
166     die "Script error 1" if ($pdiv[-1] != $ns2);
167     # Shirley-Chiu mapping from unit square to disk
168     $sq2disk = '
169     in_square_a = 2*in_square_x - 1;
170     in_square_b = 2*in_square_y - 1;
171     in_square_rgn = if(in_square_a + in_square_b,
172     if(in_square_a - in_square_b, 1, 2),
173     if(in_square_b - in_square_a, 3, 4));
174     out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
175     -in_square_a, -in_square_b);
176     out_disk_phi = PI/4 * select(in_square_rgn,
177     in_square_b/in_square_a,
178     2 - in_square_a/in_square_b,
179     4 + in_square_b/in_square_a,
180     if(in_square_b*in_square_b,
181     6 - in_square_a/in_square_b, 0));
182     Dx = out_disk_r*cos(out_disk_phi);
183     Dy = out_disk_r*sin(out_disk_phi);
184     Dz = sqrt(1 - out_disk_r*out_disk_r);
185     ';
186     # Shirley-Chiu mapping from unit disk to square
187     $disk2sq = '
188     norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
189     in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
190     in_disk_phi = norm_radians(atan2(Dy, Dx));
191     in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
192     out_square_a = select(in_disk_rgn,
193     in_disk_r,
194     (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
195     -in_disk_r,
196     (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
197     out_square_b = select(in_disk_rgn,
198     in_disk_phi*in_disk_r/(PI/4),
199     in_disk_r,
200     (PI - in_disk_phi)*in_disk_r/(PI/4),
201     -in_disk_r);
202     out_square_x = (out_square_a + 1)/2;
203     out_square_y = (out_square_b + 1)/2;
204     ';
205     # Announce ourselves in XML output
206 greg 2.16 print "\t<DataDefinition>\n";
207     print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
208     print "\t</DataDefinition>\n";
209 greg 2.15 # Fork parallel rtcontrib processes to compute each side
210     if ( $doback ) {
211     for (my $proc = 0; $proc < $nproc; $proc++) {
212     bg_tree_rtcontrib(0, $proc);
213     }
214     while (wait() >= 0) {
215     die "rtcontrib process reported error" if ( $? );
216     }
217     ttree_out(0);
218     }
219     if ( $doforw ) {
220     for (my $proc = 0; $proc < $nproc; $proc++) {
221     bg_tree_rtcontrib(1, $proc);
222     }
223     while (wait() >= 0) {
224     die "rtcontrib process reported error" if ( $? );
225     }
226     ttree_out(1);
227     }
228     } # end of sub do_tree_bsdf()
229    
230     # Run i'th rtcontrib process for generating tensor tree samples
231     sub bg_tree_rtcontrib {
232     my $pid = fork();
233     die "Cannot fork new process" unless defined $pid;
234     if ($pid > 0) { return $pid; }
235     my $forw = shift;
236     my $pn = shift;
237     my $pbeg = $pdiv[$pn];
238     my $plen = $pdiv[$pn+1] - $pbeg;
239     my $matargs = "-m $bmodnm";
240     if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
241     my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
242     "-e '$disk2sq' -bn '$ns*$ns' " .
243     "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
244     "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
245     if ( $tensortree == 3 ) {
246     # Isotropic BSDF
247     $cmd = "cnt $plen $ny $nx " .
248     "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
249     "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
250     "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
251 greg 2.18 "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
252 greg 2.15 "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
253     "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
254     "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
255     "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
256     "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
257     "| $cmd";
258     } else {
259     # Anisotropic BSDF
260     # Sample area vertically to improve load balance, since
261     # shading systems usually have bilateral symmetry (L-R)
262     $cmd = "cnt $plen $ns $ny $nx " .
263     "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
264     "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
265     "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
266     "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
267     "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
268     "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
269     "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
270     "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
271     "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
272     "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
273     "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
274     "| $cmd";
275     }
276     # print STDERR "Starting: $cmd\n";
277     exec($cmd); # no return; status report to parent via wait
278     die "Cannot exec: $cmd\n";
279     } # end of bg_tree_rtcontrib()
280    
281     # Simplify and output tensor tree results
282     sub ttree_out {
283     my $forw = shift;
284     my $side = ("Back","Front")[$forw];
285     # Only output one transmitted distribution, preferring backwards
286     if ( !$forw || !$doback ) {
287     print
288     ' <WavelengthData>
289     <LayerNumber>System</LayerNumber>
290     <Wavelength unit="Integral">Visible</Wavelength>
291     <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
292     <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
293     <WavelengthDataBlock>
294     <WavelengthDataDirection>Transmission</WavelengthDataDirection>
295     <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
296     <ScatteringDataType>BTDF</ScatteringDataType>
297     <ScatteringData>
298     ';
299     system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
300     q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
301     "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
302     "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
303     die "Failure running rttree_reduce" if ( $? );
304     print
305     ' </ScatteringData>
306     </WavelengthDataBlock>
307     </WavelengthData>
308     ';
309     }
310     # Output reflection
311     print
312     ' <WavelengthData>
313     <LayerNumber>System</LayerNumber>
314     <Wavelength unit="Integral">Visible</Wavelength>
315     <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
316     <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
317     <WavelengthDataBlock>
318 greg 2.17 ';
319     print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
320     print '
321 greg 2.15 <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
322     <ScatteringDataType>BRDF</ScatteringDataType>
323     <ScatteringData>
324     ';
325     system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
326     q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
327     "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
328     "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
329     die "Failure running rttree_reduce" if ( $? );
330     print
331     ' </ScatteringData>
332     </WavelengthDataBlock>
333     </WavelengthData>
334     ';
335     } # end of ttree_out()
336    
337     #------------- End of do_tree_bsdf() & subroutines -------------#
338    
339     #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
340     sub do_matrix_bsdf {
341     # Set up sampling of portal
342 greg 2.1 # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
343 greg 2.15 $tcal = '
344 greg 2.1 DEGREE : PI/180;
345 greg 2.5 sq(x) : x*x;
346 greg 2.1 Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
347     Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
348     Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
349     Kmax : Kaccum(Knaz(0));
350     Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
351     Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
352     Kcol = Kbin - Kaccum(Krow-1);
353 greg 2.2 Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
354 greg 2.1 Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
355     sin_kpol = sin(Kpol);
356 greg 2.9 Dx = cos(Kazi)*sin_kpol;
357 greg 2.1 Dy = sin(Kazi)*sin_kpol;
358     Dz = sqrt(1 - sin_kpol*sin_kpol);
359 greg 2.5 KprojOmega = PI * if(Kbin-.5,
360     (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
361     1 - sq(cos(Kpola(1)*DEGREE)));
362 greg 2.1 ';
363 greg 2.9 # Compute Klems bin from exiting ray direction (forward or backward)
364 greg 2.15 $kcal = '
365 greg 2.1 DEGREE : PI/180;
366 greg 2.11 abs(x) : if(x, x, -x);
367 greg 2.1 Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
368     posangle(a) : if(-a, a + 2*PI, a);
369     Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
370     kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
371     knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
372     kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
373     kfindrow(r, pol) : if(r-kpola(0)+.5, r,
374     if(pol-kpola(r), kfindrow(r+1, pol), r) );
375     kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
376     kbin2(pol,azi) = select(kfindrow(1, pol),
377     kazn(azi,360/knaz(1)),
378     kaccum(1) + kazn(azi,360/knaz(2)),
379     kaccum(2) + kazn(azi,360/knaz(3)),
380     kaccum(3) + kazn(azi,360/knaz(4)),
381     kaccum(4) + kazn(azi,360/knaz(5)),
382     kaccum(5) + kazn(azi,360/knaz(6)),
383     kaccum(6) + kazn(azi,360/knaz(7)),
384     kaccum(7) + kazn(azi,360/knaz(8)),
385     kaccum(8) + kazn(azi,360/knaz(9))
386     );
387 greg 2.11 kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
388 greg 2.1 ';
389     my $ndiv = 145;
390 greg 2.3 # Compute scattering data using rtcontrib
391 greg 2.9 my @tfarr;
392     my @rfarr;
393     my @tbarr;
394     my @rbarr;
395     my $cmd;
396 greg 2.15 my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
397 greg 2.9 "-e '$kcal' -b kbin -bn $ndiv " .
398 greg 2.15 "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
399 greg 2.9 my $rccmd = "rcalc -e '$tcal' " .
400     "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
401     q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega'};
402     if ( $doforw ) {
403     $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
404 greg 2.11 "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
405     "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
406 greg 2.10 "-e 'zp:$dim[4]' " .
407 greg 2.11 q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
408 greg 2.10 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
409 greg 2.9 "| $rtcmd";
410     system "$cmd" || die "Failure running: $cmd\n";
411     @tfarr = `$rccmd $td/$fmodnm.flt`;
412     die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
413     @rfarr = `$rccmd $td/$bmodnm.flt`;
414     die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
415     }
416     if ( $doback ) {
417     $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
418     "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
419     "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
420 greg 2.10 "-e 'zp:$dim[5]' " .
421 greg 2.9 q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
422 greg 2.11 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
423 greg 2.9 "| $rtcmd";
424     system "$cmd" || die "Failure running: $cmd\n";
425     @tbarr = `$rccmd $td/$bmodnm.flt`;
426     die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
427     @rbarr = `$rccmd $td/$fmodnm.flt`;
428     die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
429     }
430 greg 2.15 # Output angle basis
431 greg 2.1 print
432 greg 2.15 ' <DataDefinition>
433     <IncidentDataStructure>Columns</IncidentDataStructure>
434     <AngleBasis>
435 greg 2.1 <AngleBasisName>LBNL/Klems Full</AngleBasisName>
436 greg 2.15 <AngleBasisBlock>
437 greg 2.1 <Theta>0</Theta>
438     <nPhis>1</nPhis>
439     <ThetaBounds>
440 greg 2.15 <LowerTheta>0</LowerTheta>
441     <UpperTheta>5</UpperTheta>
442 greg 2.1 </ThetaBounds>
443     </AngleBasisBlock>
444     <AngleBasisBlock>
445     <Theta>10</Theta>
446     <nPhis>8</nPhis>
447     <ThetaBounds>
448     <LowerTheta>5</LowerTheta>
449     <UpperTheta>15</UpperTheta>
450     </ThetaBounds>
451     </AngleBasisBlock>
452     <AngleBasisBlock>
453     <Theta>20</Theta>
454     <nPhis>16</nPhis>
455     <ThetaBounds>
456     <LowerTheta>15</LowerTheta>
457     <UpperTheta>25</UpperTheta>
458     </ThetaBounds>
459     </AngleBasisBlock>
460     <AngleBasisBlock>
461     <Theta>30</Theta>
462     <nPhis>20</nPhis>
463     <ThetaBounds>
464     <LowerTheta>25</LowerTheta>
465     <UpperTheta>35</UpperTheta>
466     </ThetaBounds>
467     </AngleBasisBlock>
468     <AngleBasisBlock>
469     <Theta>40</Theta>
470     <nPhis>24</nPhis>
471     <ThetaBounds>
472     <LowerTheta>35</LowerTheta>
473     <UpperTheta>45</UpperTheta>
474     </ThetaBounds>
475     </AngleBasisBlock>
476     <AngleBasisBlock>
477     <Theta>50</Theta>
478     <nPhis>24</nPhis>
479     <ThetaBounds>
480     <LowerTheta>45</LowerTheta>
481     <UpperTheta>55</UpperTheta>
482     </ThetaBounds>
483     </AngleBasisBlock>
484     <AngleBasisBlock>
485     <Theta>60</Theta>
486     <nPhis>24</nPhis>
487     <ThetaBounds>
488     <LowerTheta>55</LowerTheta>
489     <UpperTheta>65</UpperTheta>
490     </ThetaBounds>
491     </AngleBasisBlock>
492     <AngleBasisBlock>
493     <Theta>70</Theta>
494     <nPhis>16</nPhis>
495     <ThetaBounds>
496     <LowerTheta>65</LowerTheta>
497     <UpperTheta>75</UpperTheta>
498     </ThetaBounds>
499     </AngleBasisBlock>
500     <AngleBasisBlock>
501     <Theta>82.5</Theta>
502     <nPhis>12</nPhis>
503     <ThetaBounds>
504     <LowerTheta>75</LowerTheta>
505     <UpperTheta>90</UpperTheta>
506     </ThetaBounds>
507     </AngleBasisBlock>
508     </AngleBasis>
509     </DataDefinition>
510 greg 2.9 ';
511     if ( $doforw ) {
512 greg 2.15 print
513     ' <WavelengthData>
514 greg 2.9 <LayerNumber>System</LayerNumber>
515     <Wavelength unit="Integral">Visible</Wavelength>
516     <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
517     <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
518     <WavelengthDataBlock>
519     <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
520     <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
521     <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
522     <ScatteringDataType>BTDF</ScatteringDataType>
523     <ScatteringData>
524     ';
525     # Output front transmission (transposed order)
526     for (my $od = 0; $od < $ndiv; $od++) {
527     for (my $id = 0; $id < $ndiv; $id++) {
528     print $tfarr[$ndiv*$id + $od];
529     }
530     print "\n";
531     }
532     print
533 greg 2.15 ' </ScatteringData>
534     </WavelengthDataBlock>
535 greg 2.9 </WavelengthData>
536 greg 2.1 <WavelengthData>
537     <LayerNumber>System</LayerNumber>
538     <Wavelength unit="Integral">Visible</Wavelength>
539     <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
540     <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
541     <WavelengthDataBlock>
542 greg 2.9 <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
543     <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
544     <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
545     <ScatteringDataType>BRDF</ScatteringDataType>
546     <ScatteringData>
547     ';
548     # Output front reflection (transposed order)
549     for (my $od = 0; $od < $ndiv; $od++) {
550     for (my $id = 0; $id < $ndiv; $id++) {
551     print $rfarr[$ndiv*$id + $od];
552     }
553     print "\n";
554     }
555     print
556 greg 2.15 ' </ScatteringData>
557     </WavelengthDataBlock>
558 greg 2.9 </WavelengthData>
559     ';
560     }
561     if ( $doback ) {
562 greg 2.15 print
563     ' <WavelengthData>
564 greg 2.9 <LayerNumber>System</LayerNumber>
565     <Wavelength unit="Integral">Visible</Wavelength>
566     <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
567     <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
568     <WavelengthDataBlock>
569     <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
570 greg 2.1 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
571     <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
572     <ScatteringDataType>BTDF</ScatteringDataType>
573     <ScatteringData>
574     ';
575 greg 2.9 # Output back transmission (transposed order)
576 greg 2.3 for (my $od = 0; $od < $ndiv; $od++) {
577     for (my $id = 0; $id < $ndiv; $id++) {
578 greg 2.9 print $tbarr[$ndiv*$id + $od];
579     }
580     print "\n";
581     }
582     print
583 greg 2.15 ' </ScatteringData>
584     </WavelengthDataBlock>
585 greg 2.9 </WavelengthData>
586     <WavelengthData>
587     <LayerNumber>System</LayerNumber>
588     <Wavelength unit="Integral">Visible</Wavelength>
589     <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
590     <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
591     <WavelengthDataBlock>
592     <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
593     <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
594     <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
595     <ScatteringDataType>BRDF</ScatteringDataType>
596     <ScatteringData>
597     ';
598     # Output back reflection (transposed order)
599     for (my $od = 0; $od < $ndiv; $od++) {
600     for (my $id = 0; $id < $ndiv; $id++) {
601     print $rbarr[$ndiv*$id + $od];
602 greg 2.3 }
603     print "\n";
604     }
605 greg 2.1 print
606 greg 2.15 ' </ScatteringData>
607     </WavelengthDataBlock>
608 greg 2.1 </WavelengthData>
609 greg 2.9 ';
610     }
611 greg 2.15 }
612     #------------- End of do_matrix_bsdf() --------------#